


.nolist
.include "m8def.inc"
.list

.equ clock = 4000000     ; Systemtakt in Hz 

;uart baudrate
.equ BAUD = 19200;9600





;Leds an PortB 1 und 2

.equ empfon1_port=portB         
.equ empfon1_ddr=ddrB 
.equ empfon1_bit=pb1 


.equ empfon2_port=portB         
.equ empfon2_ddr=ddrB 
.equ empfon2_bit=pb2 






.def temp	=	r16
.def adress =	r17
.def sregtemp =	r18





.cseg
.org	0
; hier geht das Programm los
; Interrupt-Vektoren
;
reset:	rjmp	reset1		;Programm-Start
intr0:	reti			;External Interrupt Request 0
intr1:	reti			;External Interrupt Request 1
t2comp:	reti			;Timer/Counter2 Compare Match
t2ovf:	reti			;Timer/Counter2 Overflow
t1capt:	reti			;Timer/Counter1 Capture Event
t1coma:	reti			;Timer/Counter1 Compare Match A
t1comb:	reti			;Timer/Counter1 Compare Match B
t1ovf:	reti			;Timer/Counter1 Overflow
t0ovf:	reti			;Timer/Counter0 Overflow
spistc:	reti			;SPI, STC Serial Transfer Complete
usrxc:	rjmp  Rx_int; 			;RXC USART, Rx Complete
usudre:	reti			;UDRE USART Data Register Empty
ustxc:	reti			;TXC USART, Tx Complete
adc_cc:	reti			;ADC Conversion Complete
ee_rdy:	reti			;EEPROM Ready
anacom:	reti			;Analog Comparator
twi:	reti			;Two-wire Serial Interface
spmrdy:	reti			;Store Program Memory Ready


     
reset1:

ldi temp, Low(RAMEND)
out SPL, temp
ldi temp, high(RAMEND)
out SPH, temp          ;Stack Pointer Intialisieren



sbi empfon1_port-1,empfon1_bit            ; Ausgang
sbi empfon2_port-1,empfon2_bit            ; Ausgang









;UART Initalisierung
 
    ldi	temp,low((clock/(16*baud))-1)
	out	ubrrl,temp		;9600 Baud setzen
	ldi	temp,high((clock/(16*baud))-1)
	out	ubrrh,temp		
	
    ldi temp,(1<<MPCM)		 
	out UCSRA,temp			; MPCM ein

	ldi	temp,(7<<ucsz0)
	out	ucsrc,temp		;9 Datenbits, 1 Stoppbit

	ldi	temp,(1<<rxen)|(1<<rxcie);
	out	ucsrb,temp		;Sender aktivieren
;

;
sei 







;******************************************************************************
;			Hauptschleife
;******************************************************************************


mainloop:


	rjmp Mainloop

Rx_int:
 in sregtemp, sreg          ;Sreg sichern
 push temp               ;temp sichern

            in temp,UCSRB
            sbrs temp, 1<<RXB8
            rjmp empfang2        ; wenn Datenbyte

            in adress, UDR        ; Adresse
            cpi adress,168        ; vergleichen
            brne ende            ; wenn kein Adresse->ende

           
           ldi temp,0		; MPCM aus
		   out UCSRA,temp
 rjmp ende

empfang2:           
in temp, UDR           

cpi temp,1      ;wenn 1 empfangen wird dann schalte led1 an
breq led1on

rjmp ende

cpi temp,2      ;wenn 2 empfangen wird dann schalte led1 an
breq led2on

rjmp ende

led1on:
 sbi empfon1_port,empfon1_bit 
rjmp ende        

led2on:
 sbi empfon2_port,empfon2_bit     

ende:


 pop temp                ;temp wiederherstellen)
 out sreg, sregtemp        
 reti                                   

